// ********************************************************************
// Pausen-/Verzgerungsfunktionen 
// 8051-Version / SDCC 2.9.0
// Version 1.2 / Stand: 03.11.2009
// Author: Matthias Kahnt
// ********************************************************************
// Die Programmfunktionen drfen fr private Nutzung verwendet und
// verndert werden. Fr gewerbliche Nutzung ist die Zustimmung
// der Authoren erforderlich
// Kontakt: Matthias Kahnt, e-mail: az51@gmx.net
// ********************************************************************
// Die Nutzung erfolgt auf eigene Gefahr.
// Fr eventuell entstehende Schden wird keine Haftung bernommen.
// ********************************************************************
//
//
// ********************************************************************
// Verzgerungsschleife fr kurze Zeit ohne Timer
// Zeit: Wartezeit in [zeit]
//       1 = 20us
//       2 = 28us
//       3 = 36us u.s.w. (gilt fr 11.0952MHz im Normalmode/X2-Mode)
//     255 = ca. 2ms
// ********************************************************************
void delay_us(unsigned char zeit) {
unsigned char zaehler;
  for ( zaehler = zeit; zaehler; zaehler-- ) {
   _asm nop; _endasm;
#ifdef X2_MODE
   _asm nop; _endasm;
#endif
  }
}

// ********************************************************************
// Verzgerungsschleife fr lange Zeit ohne Timer
// Zeit: Wartezeit in [zeit]
//       10 = ca. 10ms
//       20 = ca. 20ms
//       30 = ca. 30ms u.s.w. (gilt fr 11.0952MHz im Normalmode/X2-Mode)
//     1000 = ca. 1s
// ********************************************************************
void delay_ms(unsigned int zeit) {
unsigned int zaehler;
  if (zeit < 10) zeit = 10;
  for (zaehler = zeit / 10; zaehler; zaehler--) {
    delay_us(255);  // dauert ca. 2ms
    delay_us(255);  // dauert ca. 2ms
    delay_us(255);  // dauert ca. 2ms
    delay_us(255);  // dauert ca. 2ms
    delay_us(255);  // dauert ca. 2ms
  }
}
