// ********************************************************************
// UART - Grundfunktionen 
// 8051-Version / GGC 4.3.2
// Version 1.23 / Stand: 08.11.2009
// Author: Matthias Kahnt
// ********************************************************************
// Die Programmfunktionen drfen fr private Nutzung verwendet und
// verndert werden. Fr gewerbliche Nutzung ist die Zustimmung
// der Authoren erforderlich
// Kontakt: Matthias Kahnt, e-mail: az51@gmx.net
// ********************************************************************
// Die Nutzung erfolgt auf eigene Gefahr.
// Fr eventuell entstehende Schden wird keine Haftung bernommen.
// ********************************************************************
//
//
// ***********************************************************************
// UART - Initialisierung
// ***********************************************************************
void usart_init(void) {
  // Serielle Schnittstelle, 8n1
  // nur die Sendefunktion freigeben
  // Timer 1 initialisieren
  TMOD = 0x20;          // 0010 0000B Timer 1: Auto-Reload (Baudrate)
  TH1  = 0xFD;		// Reloadwert Timer 1, 9600 Baud bei 11.059200 MHz
  TL1  = 0x00;
  SM0  = 0;             // Modus 1 der seriellen Schnittstelle 8Bit UART
  SM1  = 1;
  // REN  = 1;             // seriellen Empfang freigeben (wird aber nicht ausgewertet)
  PCON &= 0x7F;		//Set SMOD  
  TR1  = 1;             // Timer 1 starten
  ES   = 1;		// Interrupt der seriellen Schnittstelle
  EA   = 1;		// Globale nterruptfreigabe
}

// ***********************************************************************
// Interrupt der seriellen Schnittstelle
// ***********************************************************************
void SERIALISR() interrupt 4 using 2 {
  if (RI) RI = 0;
  if (TI) {
    TI = 0;
    sendactive = 0;
  }
}

// ***********************************************************************
// UART - Byte senden
// bergabe: zu sendendes Byte
// ***********************************************************************
void usart_send_byte(char send_byte) {
  while (sendactive);
  sendactive = 1;
  SBUF = send_byte;
}

// ***********************************************************************
// USART - Zeichnkette senden
// bergabe: Adresse der zu sendenden Zeichenkette
// ***********************************************************************
void usart_send_string(char *send_zk) {
  while (*send_zk) usart_send_byte(*send_zk++);
}
